/* 
 * Quicksort of N random integers, lowered
 */
#include <stdio.h>
#include <stdlib.h>

#include "branch.h"

void quicksort (int v[], int, int);

#define N	10000

int v[N];

int main () {
	int t;
	int i = 0;
loop1:
	v[i++] = rand ();
	if (i < N) goto loop1;
	quicksort (v, 0, N-1);
	exit (0);
}

void swap (int *a, int *b) {
	int t = *a;
	*a = *b;
	*b = t;
}
 
int partition (int v[], int lo, int hi) {
	int pivot = v[hi];
	int i = lo - 1;
 
	int j = lo;
loop1:
	if (j > hi-1) goto doneloop1;
	if (v[j] > pivot) goto dontswap;
	i++;
	swap(&v[i], &v[j]);
dontswap:
	j++;
	if (j <= hi-1) goto loop1;
doneloop1:
	swap(&v[i + 1], &v[hi]);
	return i + 1;
}
 
void quicksort(int v[], int lo, int hi) {
	int pi;
	if (lo >= hi) goto done;
	pi = partition(v, lo, hi);
	quicksort(v, lo, pi - 1);
	quicksort(v, pi + 1, hi);
done: ;
}
